unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, ComCtrls, shared, XMLDoc, XMLIntf,
  IdBaseComponent, IdCoder, IdCoder3To4, Jpeg, fileread,{fileutil,}xmlshared,
  XMLDOM;

type
  TfMain = class(TForm)
    PageControl1: TPageControl;
    tshTextP: TTabSheet;
    tshBookP: TTabSheet;
    tshFileP: TTabSheet;
    TabSheet4: TTabSheet;
    lbeBookName: TLabeledEdit;
    lbeGenre: TLabeledEdit;
    lbeFB2Descr: TLabeledEdit;
    lbeFileName: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    imgCover: TImage;
    IdBase64Decoder1: TIdBase64Decoder;
    mmAnnotation: TMemo;
    Label1: TLabel;
    lbePBookName: TLabeledEdit;
    lbePublisher: TLabeledEdit;
    lbePCity: TLabeledEdit;
    lbePYear: TLabeledEdit;
    lbeISBN: TLabeledEdit;
    LabeledEdit1: TLabeledEdit;
    procedure LoadBook(FileName:string);
  private
    TotCmdWin: HWND;    //handle of TC window
    ParentWin: HWND;    //handle of Lister window
    QuickView: boolean; //Ctrl+Q panel
    procedure AppException(Sender: TObject; E: Exception);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    //our constructor
    constructor CreateParented(ParentWindow: HWND; const FileToView: string); reintroduce;
  end;

function ShowPlugin(ListerWin: HWND; FileToLoad: string): HWND;

implementation

{$R *.dfm}

procedure wMsgBox(hWnd: HWND; Msg: string);
begin
  MessageBox(hWnd, PChar(Msg), 'Message', MB_OK+MB_ICONINFORMATION);
end;

procedure TfMain.LoadBook(FileName:string);
const cerr=' ';
var
 xmld:ixmldocument;
 xnFB,xnTmp:ixmlnode;
 i:integer;
 tmpFile:tFileWrite;
 tmpFileName:string;
 CoverLnk:string;
 s1,s2:string;
begin
  xmld:=txmldocument.Create(FileName);
  xnFB:=getRootNode(xmld,'FictionBook');
  lbeBookName.Text:=GetTextByLongName(xnFB,'description/title-info/book-title');
  lbefb2descr.Text:=GetTextByLongName(xnFB,'description/title-info/genre');
  mmAnnotation.Lines.Text:=GetNodeByLongName(xnFB,'description/title-info/annotation').XML;
  xnTmp:=GetNodeByLongName(xnFB,'description/title-info/coverpage/image');
  CoverLnk:='';
  for i:=0 to xnTmp.AttributeNodes.Count-1 do begin
   if ExtractLocalName(xnTmp.AttributeNodes[i].NodeName)='href' then begin
    CoverLnk:=vartostr(xnTmp.AttributeNodes[i].Text);
    break
   end;
  end;
  Brush.Color:=clBtnFace;
  Font.Charset:=RUSSIAN_CHARSET;
  Font.Size:=16;
  if CoverLnk='' then
  with imgCover.Canvas do begin
   Rectangle(0,0,imgCover.Width,imgCover.Height);
   TextOut((imgCover.Width-TextWidth(cerr))div 2,
   (imgCover.Height-TextHeight(cerr))div 2,cerr);
  end else begin
   s1:='';s2:='';
   labelededit1.Text:=CoverLnk;
   xnTmp:=xnFB.ChildNodes['binary'];
   idbase64decoder1.Reset;
   s1:=vartostr(xnTmp.text);
   if s1<>'' then begin
   s2:=idbase64decoder1.CodeString(s1);
   tmpFileName:=vartostr(xnTmp.Attributes['id']);
   if tmpFileName='' then tmpFileName:='nil.jpg';
   tmpFileName:='d:\temp\'+tmpFileName;
   tmpFile:=tFileWrite.Create(tmpFileName);
   tmpFile.writestring(copy(s2,3,maxint));
   tmpFile.Free;
   try
   imgCover.Picture.LoadFromFile(tmpFileName);
   except
    on E: Exception do   with imgCover.Canvas do begin
    Rectangle(0,0,imgCover.Width,imgCover.Height);
   TextOut((imgCover.Width-TextWidth(E.Message))div 2,
   (imgCover.Height-TextHeight(E.Message))div 2,E.Message);
end;
//    ErrorDialog(, E.HelpContext);
   end;
  end;
  end;
end;

procedure TfMain.AppException(Sender: TObject; E: Exception);
begin
  wMsgBox(Handle, 'Plugin Error:' + #13 + E.Message);
end;

procedure TfMain.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := (WS_CHILD or WS_MAXIMIZE) and not WS_CAPTION and not WS_BORDER;
  Params.WindowClass.cbWndExtra := SizeOf(Pointer); //4 bytes for address of form
end;

constructor TfMain.CreateParented(ParentWindow: HWND; const FileToView: string);
const WinCmdClassName = 'TTOTAL_CMD';
begin //non standard constructor
  inherited CreateParented(ParentWindow); //our window is child window
  TotCmdWin := FindWindow(WinCmdClassName, nil);
  ParentWin := ParentWindow;
  QuickView := GetParent(ParentWin) <> 0;
  LoadBook(FileToView);
  //RichEdit1.Lines.LoadFromFile(FileToView);
end;
{end of form}
//----------------------------------------------------------------------------------
{initialization and finalization}
type
  TPlugInfo = record
    PlugWinProc: Pointer; //callback function of our form
    PlugForm: TfMain;    //our form
  end;

procedure HideRTF(PluginWin: HWND);
var p: ^TPlugInfo;
begin //finalization
  p := Pointer(GetWindowLong(PluginWin, GWL_USERDATA));
  with p^.PlugForm do begin
    try
      Application.RemoveComponent(p^.PlugForm);
      Application.Handle := 0;
      //restore callback function
      SetWindowLong(Handle, GWL_WNDPROC, Integer(p^.PlugWinProc));
      Free;
    except
      on E: Exception do
        wMsgBox(0, 'DestroyWindow error:' + #13 + E.Message);
    end;
  end;
  Dispose(p);
end;

function HookDestroy(PluginWin: HWND; Msg, wParam, lParam: LongInt): LongInt; stdcall;
var p: ^TPlugInfo;
begin //hook destroy our window
  p := Pointer(GetWindowLong(PluginWin, GWL_USERDATA));
  if Msg <> WM_DESTROY then
    Result := CallWindowProc(p^.PlugWinProc, PluginWin, Msg, wParam, lParam)
  else begin //plugin close
    HideRTF(PluginWin);
    Result := 0;
  end;
end;

function ShowPlugin(ListerWin: HWND; FileToLoad: string): HWND;
var fmMain: TfMain; s: string; p: ^TPlugInfo;
begin //initialization
  try
    s := ExtractFilePath(FileToLoad);
    if not SetCurrentDir(s) then  //folder of RTF
      raise Exception.Create('Error of SetCurrentDir() for Folder: ' + s);
    fmMain := TfMain.CreateParented(ListerWin, FileToLoad);
    fmMain.Show;
    //synchronize our form and Lister
    Application.Handle := ListerWin;
    Application.OnException := fmMain.AppException;
    Application.InsertComponent(fmMain);
    //substitution callback function
    New(p);
    SetWindowLong(fmMain.Handle, GWL_USERDATA, Integer(p));
    p^.PlugForm := fmMain;
    p^.PlugWinProc := Pointer(SetWindowLong(fmMain.Handle, GWL_WNDPROC, Integer(@HookDestroy)));
    //set focus to our window
    if not fmMain.QuickView then begin
      PostMessage(fmMain.Handle, WM_SETFOCUS, 0, 0);
//      fmMain.RichEdit1.SetFocus;
    end;
    Result := fmMain.Handle;
    fmMain.Font.Size:=8;
  except
    on E: Exception do begin
      wMsgBox(ListerWin, 'Open error:' + #13 + E.Message);
      Result := 0;
    end;
  end;
end;

end.
