unit shared;

interface

type
  chars = set of char;

const
  cr = #13;
  lf = #10;
  crlf = #13#10;
  br = crlf;
procedure exec(const FileName, WorkDir: string);
{   }
procedure wMsgBox(hWnd: tHandle; Msg: PChar); { MessageBox }
function ffUpCase(const ch: char): char;
function UpCaseStr(S: string): string;
function IntToStrL(i, slength: integer): string;
{ IntToStr  . Ex: 001 }

function StrToPQStr(const str: string): string;
function PQStrToStr(const QStr: string; var pos: integer): string;
function StrToQStr(str: string): string;
function QStrToStr(const QStr: string): string;
function ConcatQStr(s1, s2: string): string;

function CheckShortFN(FileName: string): string;
{         }
function GetUniqueFileName(const FileName: string): string;
{         . Ex: somefile01.ext }
function CheckLongFN(const CurrentDir: string; FileName: string): string;
{    
     C:\A\\B\.\C\..\D\fn.ext  C:\A\B\D\fn.ext }
function GetRelativePath(const BaseName, DestName: string): string;

function GetStringFromFile(const FileName: PChar; bPos, ePos: integer): string;
procedure WriteStringToFile(const FileName: PChar; const str: string);

function ExtractVars(const Mask: string; Source: string): string;
{   Source ,   Mask      INI- }
function PutVars(const Source, Vars: string): string;
function GetVarValue(Vars: string; const VarName: string): string;
function GetVarValueDel(var Vars: string; const VarName: string): string;
function ClearString(S: string; const divider: string;
  const delempvals: boolean): string;
function CompareVarLists(VarList1, VarList2: string): boolean;

function ReplaceChar(const str: string; find, repl: char): string;
function ExcludeChars(const S: string; const chEx: chars): string;

function Copy2Symb(const S: string; Symb: char): string;
function Copy2SymbDel(var S: string; Symb: char): string;
function Copy2Str(const S: string; Symb: string): string;
function Copy2StrDel(var S: string; Symb: string): string;

function ReplaceStr(const S, Srch, Replace: string): string;

function EncodeBase64(const inStr: AnsiString): AnsiString;
// function DecodeBase64(cStr:string):string;
function DecodeBase64(const CinLine: AnsiString): AnsiString;
function DecodeBase64U(const CinLine: UnicodeString): AnsiString;

implementation

uses SysUtils, windows;
// const br=#13#10;

procedure exec(const FileName: string; const WorkDir: string);
var
  zAppName: array [0 .. 512] of char;
  zCurDir: array [0 .. 255] of char;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  StrPCopy(zAppName, FileName);
  StrPCopy(zCurDir, WorkDir);
  FillChar(StartupInfo, Sizeof(StartupInfo), #0);
  StartupInfo.cb := Sizeof(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := 1;
  CreateProcess(nil, zAppName, nil, nil, false, CREATE_NEW_CONSOLE or
    NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInfo)
end;

function ffUpCase(const ch: char): char;
begin
  case ch of
    'a' .. 'z', '' .. '':
      result := chr(ord(ch) - 32);
  else
    result := ch;
  end; { case }
end;

function UpCaseStr(S: string): string;
var
  i: integer;
begin
  for i := 1 to Length(S) do
    S[i] := ffUpCase(S[i]);
  result := S;
end;

procedure wMsgBox(hWnd: tHandle; Msg: PChar);
begin
  MessageBox(hWnd, Msg, 'Message', MB_OK + MB_ICONINFORMATION);
end;

function StrToPQStr(const str: string): string;
var
  i: integer;
  mode: byte;
begin
  result := '';
  mode := 2;
  for i := 1 to Length(str) do
    case str[i] of
      #0 .. #32, '''', '"':
        begin
          if mode = 1 then
          begin
            result := result + '''';
            mode := 2;
          end;
          result := result + '#' + IntToStrL(ord(str[i]), 2);
        end;
    else
      begin
        if mode = 2 then
        begin
          result := result + '''';
          mode := 1;
        end;
        result := result + str[i];
      end;
    end; { case }
  if mode = 1 then
    result := result + '''';
end;

function PQStrToStr(const QStr: string; var pos: integer): string;
var
  sn: string;
  bn: byte;
  err: integer;
  go: boolean;
  l, p: integer;
begin
  p := pos;
  if p < 1 then
    p := 1;
  result := '';
  go := true;
  l := Length(QStr);
  while (p < l) and (CharInSet(QStr[p], [#9, #10, #13, ' '])) do
    inc(p);
  while (p < l) and go do
    case QStr[p] of
      '#':
        begin
          inc(p);
          sn := '';
          if (p < l) and (QStr[p] = '$') then
          begin
            sn := '$';
            while (p < l) and
              (CharInSet(QStr[p], ['0' .. '9', 'A' .. 'F', 'a' .. 'f'])) do
            begin
              sn := sn + QStr[p];
              inc(p);
            end
          end
          else
            while (p < l) and (CharInSet(QStr[p], ['0' .. '9'])) do
            begin
              sn := sn + QStr[p];
              inc(p);
            end;
          val(sn, bn, err);
          if err = 0 then
            result := result + chr(bn)
          else
            result := result + '#' + sn;
        end;
      '''':
        begin
          inc(p);
          while (p < l) and (QStr[p] <> '''') do
          begin
            result := result + QStr[p];
            inc(p);
          end;
          inc(p);
        end;
    else
      go := false;
    end; { case }
  pos := p;
end;

function StrToQStr(str: string): string;
var
  i, l: integer;
begin
  l := Length(str);
  i := 1;
  while i <= l do
  begin
    if str[i] = '"' then
    begin
      insert('"', str, i);
      inc(i);
      inc(l);
    end;
    inc(i);
  end;
  result := '"' + str + '"';
end;

function QStrToStr(const QStr: string): string;
var
  q: char;
  i: integer;
begin
  if (Length(QStr) < 2) or ((QStr[1] <> '''') and (QStr[1] <> '"')) then
    result := QStr
  else
  begin
    q := QStr[1];
    i := Length(QStr);
    while QStr[i] <> q do
      dec(i);
    result := copy(QStr, 2, i - 2);
  end;
end;

function ConcatQStr(s1, s2: string): string;
begin
  if (s1 = '') or (s2 = '') then
    result := s1 + s2
  else if (s1[Length(s1)] = '''') and (s2[1] = '''') then
    result := copy(s1, 0, Length(s1) - 1) + copy(s2, 2, maxint)
  else if (s2[1] <> '''') and (s1[Length(s1)] <> '''') then
    result := s1 + '''''' + s2
  else
    result := s1 + s2;
end;

function CheckShortFN(FileName: string): string;
var
  i, l: integer;
begin
  FileName := copy(FileName, 0, 255);
  l := Length(FileName);
  while FileName[l] = ' ' do
    dec(l);
  FileName := copy(FileName, 0, l);
  for i := 1 to Length(FileName) do
    if CharInSet(FileName[i], ['/', '\', '?', '*', '"', '|', '<', '>', ':']) then
      FileName[i] := '_';
end;

function GetUniqueFileName(const FileName: string): string;
var
  i: integer;
begin
  i := 0;
  result := FileName;
  while fileexists(result) do
  begin
    inc(i);
    result := changefileext(FileName, IntToStrL(i, 2) +
      ExtractFileExt(FileName))
  end;
end;

function GetStringFromFile(const FileName: PChar; bPos, ePos: integer): string;
// const maxlen=10*1024*1024;//65536;
var
  f: tHandle;
  err: Cardinal;
  fs: integer;
begin
  f := CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL + FILE_FLAG_SEQUENTIAL_SCAN, 0);
  if f = INVALID_HANDLE_VALUE then
  begin
    result := '';
    exit;
  end;
  SetFilePointer(f, bPos, nil, FILE_BEGIN);
  fs := GetFileSize(f, nil);
  if ePos > fs then
    ePos := fs;
  { if ePos-bPos>maxlen-1 then ePos:=maxlen-1 else } ePos := ePos - bPos;
  SetLength(result, ePos + 1);
  ReadFile(f, (PChar(result))^, ePos, err, nil);
  SetLength(result, err);
  FileClose(f);
end;

procedure WriteStringToFile(const FileName: PChar; const str: string);
var
  f: tHandle;
  err: Cardinal;
begin
  f := CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_READ, nil, CREATE_ALWAYS,
    FILE_ATTRIBUTE_NORMAL + FILE_FLAG_SEQUENTIAL_SCAN, 0);
  WriteFile(f, (PChar(str))^, Length(str), err, nil);
  FileClose(f);
end;

function CheckLongFN(const CurrentDir: string; FileName: string): string;
var
  l, w, r, t: integer;
begin
  l := Length(FileName);
  if l = 0 then
  begin
    result := '';
    exit;
  end;
  if (l < 3) or not((CharInSet(FileName[1], ['A' .. 'Z', 'a' .. 'z'])) and
    (FileName[2] = ':') and (FileName[3] = '\')) then
  begin
    if FileName[1] = '\' then
      FileName := copy(CurrentDir, 0, 2) + FileName
    else
      FileName := CurrentDir + '\' + FileName;
  end;
  {      }
  w := 3;
  r := 4;
  l := Length(FileName);
  while r <= l do
  begin
    if CharInSet(FileName[r], ['/', '?', '*', '"', '|', '<', '>', ':', #13, #10, #0])
    then
      inc(r)
    else if (FileName[w] = '\') and (FileName[r] = '\') then
      inc(r)
    else if (FileName[w] = ' ') and (FileName[r] = '\') then
      dec(w)
    else if (FileName[w] = '\') and (FileName[r] = '.') then
    begin
      t := 1;
      while ((r + t) <= l) and (FileName[r + t] = '.') do
        inc(t);
      if FileName[r + t] = '\' then
      begin
        r := r + t;
        while (w > 3) and (t > 0) do
        begin
          if FileName[w] = '\' then
            dec(t);
          dec(w);
        end;
      end
      else
      begin
        inc(w);
        FileName[w] := FileName[r];
        inc(r);
      end;
    end
    else
    begin
      inc(w);
      FileName[w] := FileName[r];
      inc(r);
    end;
  end;
  if FileName[w] = '\' then
    dec(w);
  result := copy(FileName, 0, w);
end;

function GetRelativePath(const BaseName, DestName: string): string;
var
  BasePath, DestPath: string;
  BaseLead, DestLead: PChar;
  BasePtr, DestPtr: PChar;

  function ExtractFilePathNoDrive(const FileName: string): string;
  begin
    result := ExtractFilePath(FileName);
    Delete(result, 1, Length(ExtractFileDrive(FileName)));
  end;

  function Next(var Lead: PChar): PChar;
  begin
    result := Lead;
    if result = nil then
      exit;
    Lead := AnsiStrScan(Lead, '\');
    if Lead <> nil then
    begin
      Lead^ := #0;
      inc(Lead);
    end;
  end;

begin
  if SameFilename(ExtractFileDrive(BaseName), ExtractFileDrive(DestName)) then
  begin
    BasePath := ExtractFilePathNoDrive(BaseName);
    DestPath := ExtractFilePathNoDrive(DestName);
    BaseLead := Pointer(BasePath);
    BasePtr := Next(BaseLead);
    DestLead := Pointer(DestPath);
    DestPtr := Next(DestLead);
    while (BasePtr <> nil) and (DestPtr <> nil) and
      SameFilename(BasePtr, DestPtr) do
    begin
      BasePtr := Next(BaseLead);
      DestPtr := Next(DestLead);
    end;
    result := '';
    while BaseLead <> nil do
    begin
      result := result + '..\';
      Next(BaseLead);
    end;
    if (DestPtr <> nil) and (DestPtr^ <> #0) then
      result := result + DestPtr + '\';
    if DestLead <> nil then
      result := result + DestLead; // destlead already has a trailing backslash
    result := result + ExtractFileName(DestName);
  end
  else
    result := DestName;
end;

function IntToStrL(i, slength: integer): string;
begin
  result := inttostr(i);
  while Length(result) < slength do
    result := '0' + result;
end;

{      : , , , .  Ѩ!!! }
function ExtractVars(const Mask: string; Source: string): string;
var
  pm, lm, t, t1: integer;
  vn, vv: string;
  nerr: boolean;
  st: string;
begin
  result := '';
  nerr := true;
  if (Mask = '') or (Mask = #39) or (Mask = #39#39) then
    exit;
  pm := 1;
  lm := Length(Mask);
  while (Source <> '') and nerr and (Mask[pm] <> '.') do
  begin
    case Mask[pm] of
      '''':
        begin
          vn := PQStrToStr(Mask, pm);
          st := copy(Source, 1, Length(vn));
          if vn = st then
            Source := copy(Source, Length(vn) + 1, maxint)
          else
            nerr := false;
        end;
      '*':
        begin
          inc(pm);
          vv := PQStrToStr(Mask, pm);
          if vv = '' then
            t := maxint
          else
            t := pos(vv, Source);
          if t = 0 then
            t := maxint
          else
            inc(t, Length(vv));
          Source := copy(Source, t, maxint);
        end;
    else
      begin
        t1 := pm;
        while (Mask[t1] <> '''') and (t1 <= lm) do
          inc(t1);
        vn := copy(Mask, pm, t1 - pm);
        pm := t1;
        vv := PQStrToStr(Mask, pm);
        if vv = '' then
          t := maxint
        else
          t := pos(vv, Source);
        if t = 0 then
          t1 := maxint
        else
          t1 := t + Length(vv);
        vv := copy(Source, 0, t - 1);
        Source := copy(Source, t1, maxint);
        if (vv = '') or (vn = '') then
          nerr := false
        else
          result := result + vn + '=' + vv + br;
      end;
    end;
  end;
  // if Mask[pm]='.' then inc(pm);
  if (not nerr) or (pm < lm) then
    result := 'ERROR';
end;

function PutVars(const Source, Vars: string): string;
var
  ps, ls: integer;
  t: integer;
  vn: string;
begin
  result := '';
  ls := Length(Source);
  ps := 1;
  while ps < ls do
  begin
    if CharInSet(Source[ps], [#9, #10, #13, ' ', '''']) then
    begin
      result := result + PQStrToStr(Source, ps);
    end
    else
    begin
      t := ps;
      while (Source[ps] <> '''') and (ps < ls) do
        inc(ps);
      vn := copy(Source, t, ps - t);
      result := result + GetVarValue(Vars, vn);
    end;
  end;
end;

function GetVarValue(Vars: string; const VarName: string): string;
var
  p: integer;
  t: string;
begin
  result := '';
  p := Length(VarName);
  while (Vars <> '') and (result = '') do
  begin
    t := Copy2StrDel(Vars, br);
    if copy(t, 0, p + 1) = (VarName + '=') then
      result := copy(t, p + 2, maxint);
  end;
end;

function GetVarValueDel(var Vars: string; const VarName: string): string;
var
  p: integer;
  t, t1: string;
begin
  result := '';
  p := Length(VarName);
  t1 := '';
  while (Vars <> '') and (result = '') do
  begin
    t := Copy2StrDel(Vars, br);
    if copy(t, 0, p + 1) = (VarName + '=') then
      result := copy(t, p + 2, maxint)
    else
      t1 := t1 + t + br;
  end;
  Vars := t1 + Vars;
end;

function ClearString(S: string; const divider: string;
  const delempvals: boolean): string;
var
  t, t1: string;
  function CutLeadSyms(S: string; syms: chars): string;
  var
    p, i: integer;
  begin
    i := 1;
    p := Length(S);
    while (i <= p) and (CharInSet(S[i], syms)) do
      inc(i);
    result := copy(S, i, maxint);
  end;

begin
  result := '';
  if S = '' then
    exit;
  while S <> '' do
  begin
    S := CutLeadSyms(S, [#13, #10]);
    t := Copy2SymbDel(S, '=');
    t1 := CutLeadSyms(Copy2SymbDel(S, #13), [#10]);
    if not((t = '') or ((delempvals) and ((t1 = '') or (t1 = #29#29) or
      (t1 = '""')))) then
      result := result + t + '=' + t1 + divider;
  end;
end;

function CompareVarLists(VarList1, VarList2: string): boolean;
var
  t: string;
  p: integer;
begin
  result := true;
  VarList1 := ClearString(VarList1 + br, br, true);
  VarList2 := ClearString(VarList2 + br, br, true);
  if VarList1 = VarList2 then
    exit;
  if (VarList1 = '') or (VarList2 = '') then
    result := false
  else
  begin
    while result and (VarList1 <> '') do
    begin
      t := Copy2StrDel(VarList1, br) + br;
      p := pos(t, VarList2);
      if p > 0 then
        Delete(VarList2, p, Length(t))
      else
        result := false
    end;
    if VarList2 <> '' then
      result := false;
  end;
end;

function ReplaceChar(const str: string; find, repl: char): string;
var
  i: integer;
begin
  result := str;
  for i := 1 to Length(result) do
    if result[i] = find then
      result[i] := repl;
end;

function Copy2Symb(const S: string; Symb: char): string;
var
  p: integer;
begin
  p := pos(Symb, S);
  if p = 0 then
    p := Length(S) + 1;
  result := copy(S, 1, p - 1);
end;

function Copy2SymbDel(var S: string; Symb: char): string;
begin
  result := Copy2Symb(S, Symb);
  S := { DelBSpace( } copy(S, Length(result) + 2, Length(S)) { ) };
end;

function Copy2Str(const S: string; Symb: string): string;
var
  p: integer;
begin
  p := pos(Symb, S);
  if p = 0 then
    p := Length(S) + 1;
  result := copy(S, 1, p - 1);
end;

function Copy2StrDel(var S: string; Symb: string): string;
begin
  result := Copy2Str(S, Symb);
  S := { DelBSpace( } copy(S, Length(result) + 1 + Length(Symb),
    Length(S)) { ) };
end;

function ExcludeChars(const S: string; const chEx: chars): string;
var
  i: integer;
begin
  result := S;
  for i := Length(result) downto 1 do
  begin
    if CharInSet(result[i], chEx) then
      Delete(result, i, 1);
  end;
end;

function ReplaceStr(const S, Srch, Replace: string): string;
var
  i: integer;
  Source: string;
begin
  Source := S;
  result := '';
  repeat
    i := pos(Srch, Source);
    if i > 0 then
    begin
      result := result + copy(Source, 1, i - 1) + Replace;
      Source := copy(Source, i + Length(Srch), maxint);
    end
    else
      result := result + Source;
  until i <= 0;
end;

function EncodeBase64(const inStr: AnsiString): AnsiString;
  function Encode_Byte(b: byte): AnsiChar;
  const
    Base64Code: string[64]
      = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
  begin
    result := Base64Code[(b and $3F) + 1];
  end;

var
  i, j, l: integer;
  // t,t1,t2:byte;
  // t:char;
begin
  l := Length(inStr) - 3;
  if (l mod 3) = 0 then
    i := 1
  else
    i := 2;
  SetLength(result, ((l div 3) + i) * 4 + (l div 15) + 4);
  i := 1;
  j := 1;
  while i <= l do
  begin
    result[j] := Encode_Byte(byte(inStr[i]) shr 2);
    inc(j);
    result[j] := Encode_Byte(byte((byte(inStr[i]) shl 4) or
      (byte(inStr[i + 1]) shr 4)));
    inc(j);
    result[j] := Encode_Byte(byte((byte(inStr[i + 1]) shl 2) or
      (byte(inStr[i + 2]) shr 6)));
    inc(j);
    result[j] := Encode_Byte(byte(inStr[i + 2]));
    inc(j);
    if (j mod 80) < 4 then
    begin
      result[j] := #13;
      inc(j);
      result[j] := #10;
      inc(j);
    end;
    inc(i, 3);
  end;
  l := l - i + 3;
  case l of
    2:
      begin
        result[j] := Encode_Byte(byte(inStr[i]) shr 2);
        inc(j);
        result[j] := Encode_Byte(byte((byte(inStr[i]) shl 4) or
          (byte(inStr[i + 1]) shr 4)));
        inc(j);
        result[j] := Encode_Byte(byte((byte(inStr[i + 1]) shl 2) or
          (byte(inStr[i + 2]) shr 6)));
        inc(j);
        result[j] := Encode_Byte(byte(inStr[i + 2]));
      end;
    1:
      begin
        result[j] := Encode_Byte(byte(inStr[i]) shr 2);
        inc(j);
        result[j] := Encode_Byte(byte((byte(inStr[i]) shl 4) or
          (byte(inStr[i + 1]) shr 4)));
        inc(j);
        result[j] := Encode_Byte
          (byte((byte(inStr[i + 1]) shl 2) { or (Byte(inStr[i+2]) shr 6) } ));
        inc(j);
        result[j] := '=';
      end;
    0:
      begin
        result[j] := Encode_Byte(byte(inStr[i]) shr 2);
        inc(j);
        result[j] := Encode_Byte(byte(byte(inStr[i]) shl 4));
        inc(j);
        result[j] := '=';
        inc(j);
        result[j] := '=';
      end;
  end; { case }
  SetLength(result, j);
end;
(*
  function DecodeBase64(cStr:string):string;
  Const
  Base64Table='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
  var ResStr:string;
  DecStr:string;
  RecodeLine   : array [1..76] of byte;
  f1{,f2} : word;
  l:integer;
  begin
  l :=length(Base64Table);
  ResStr:='';
  for f1:=1 to l do
  if cStr[f1]='=' then RecodeLine[f1]:=0
  else RecodeLine[f1]:=pos(cStr[f1],Base64Table)-1;
  f1:=1;
  while f1<length(cStr) do
  begin
  DecStr:=chr(byte(RecodeLine[f1]   shl 2)+RecodeLine[f1+1] shr 4)+
  chr(byte(RecodeLine[f1+1] shl 4)+RecodeLine[f1+2] shr 2)+
  chr(byte(RecodeLine[f1+2] shl 6)+RecodeLine[f1+3]);
  ResStr:=ResStr+DecStr;
  inc(f1,4);
  end;
  DecodeBase64:=ResStr;
  end; *)

// Base64 decoding
function DecodeBase64(const CinLine: AnsiString): AnsiString;
const
  RESULT_ERROR = -2;
var
  inLineIndex: integer;
  c: ansichar;
  x: SmallInt;
  c4: Word;
  StoredC4: array [0 .. 3] of SmallInt;
  InLineLength: integer;
begin
  result := '';
  inLineIndex := 1;
  c4 := 0;
  InLineLength := Length(CinLine);

  while inLineIndex <= InLineLength do
  begin
    while (inLineIndex <= InLineLength) and (c4 < 4) do
    begin
      c := CinLine[inLineIndex];
      case c of
        '+':
          x := 62;
        '/':
          x := 63;
        '0' .. '9':
          x := ord(c) - (ord('0') - 52);
        '=':
          x := -1;
        'A' .. 'Z':
          x := ord(c) - ord('A');
        'a' .. 'z':
          x := ord(c) - (ord('a') - 26);
      else
        x := RESULT_ERROR;
      end;
      if x <> RESULT_ERROR then
      begin
        StoredC4[c4] := x;
        inc(c4);
      end;
      inc(inLineIndex);
    end;

    if c4 = 4 then
    begin
      c4 := 0;
      result := result + AnsiChar((StoredC4[0] shl 2) or (StoredC4[1] shr 4));
      if StoredC4[2] = -1 then
        exit;
      result := result + AnsiChar((StoredC4[1] shl 4) or (StoredC4[2] shr 2));
      if StoredC4[3] = -1 then
        exit;
      result := result + AnsiChar((StoredC4[2] shl 6) or (StoredC4[3]));
    end;
  end;
end;

function DecodeBase64U(const CinLine: UnicodeString): AnsiString;
const
  RESULT_ERROR = -2;
var
  inLineIndex: integer;
  c: ansichar;
  x: SmallInt;
  c4: Word;
  StoredC4: array [0 .. 3] of SmallInt;
  InLineLength: integer;
  p: PAnsiChar;
begin
  result := '';
  if CinLine = '' then
    Exit;
  inLineIndex := 0;
  c4 := 0;
  InLineLength := Length(CinLine) * SizeOf(Char);
  p := PAnsiChar(Pointer(CinLine));

  while inLineIndex <= InLineLength do
  begin
    while (inLineIndex <= InLineLength) and (c4 < 4) do
    begin
      c := p[inLineIndex];
      case c of
        '+':
          x := 62;
        '/':
          x := 63;
        '0' .. '9':
          x := ord(c) - (ord('0') - 52);
        '=':
          x := -1;
        'A' .. 'Z':
          x := ord(c) - ord('A');
        'a' .. 'z':
          x := ord(c) - (ord('a') - 26);
      else
        x := RESULT_ERROR;
      end;
      if x <> RESULT_ERROR then
      begin
        StoredC4[c4] := x;
        inc(c4);
      end;
      inc(inLineIndex, SizeOf(Char));
    end;

    if c4 = 4 then
    begin
      c4 := 0;
      result := result + AnsiChar((StoredC4[0] shl 2) or (StoredC4[1] shr 4));
      if StoredC4[2] = -1 then
        exit;
      result := result + AnsiChar((StoredC4[1] shl 4) or (StoredC4[2] shr 2));
      if StoredC4[3] = -1 then
        exit;
      result := result + AnsiChar((StoredC4[2] shl 6) or (StoredC4[3]));
    end;
  end;
end;

end.
